=== debian/control ===
Source: obs-studio-dmo
Section: video
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://obsproject.com
Rules-Requires-Root: no
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 13), dh-sequence-python3, cmake, quilt,
 libasound2-dev, libavfilter-dev, libv4l-dev, libx11-dev, libfreetype-dev,
 libcurl4-gnutls-dev | libcurl-dev, libdbus-1-dev, libfontconfig-dev,
 libqt5x11extras5-dev, libopengl-dev, libjack-jackd2-dev, swig, pkgconf,
 libjansson-dev (>= 2.5), libpulse-dev, libspeexdsp-dev, libxcb-xinerama0-dev,
 libudev-dev [linux-any], libx264-dev, libxcb-shm0-dev, qtbase5-dev, libftl-dev,
 libxcomposite-dev, libxinerama-dev, libvlc-dev, libx11-xcb-dev, libsimde-dev,
 python3-docutils (>= 0.6), libfdk-aac-dev, liblua5.2-dev, python3-dev,
 libmbedtls-dev, libfdk-aac-dev, libqt5svg5-dev, libxcb-xinput-dev, libasio-dev,
 libxcb-randr0-dev, libavdevice-dev, ninja-build, libpipewire-0.3-dev,
 libwayland-dev, qtbase5-private-dev, libdrm-dev, libluajit2-5.1-dev, libpci-dev,
 libxcb-composite0-dev, nv-codec-headers [amd64 arm64 i386], libxcb-dri2-0-dev,
 libxcb-glx0-dev, libxcb-keysyms1-dev, libxcb-sync-dev, libxcb-xv0-dev,
 libsrt-openssl-dev, libajantv2-dev [amd64], librist-dev, libva-dev,
 libwebsocketpp-dev, nlohmann-json3-dev

Package: obs-studio
Architecture: any
Depends: obs-plugins (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Suggests: libnvidia-encode1, pkexec | policykit-1
Replaces: obs-plugins (<= 1:26.0.0-dmo1), obs-websocket
Breaks: obs-plugins (<= 1:26.0.0-dmo1), obs-websocket
Description: recorder and streamer for live video content
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 Other features include:
  * Encoding using H264 (x264) and AAC
  * Unlimited number of scenes and sources
  * File output to MP4 or FLV
  * GPU-based game capture for high performance game streaming
  * Bilinear or lanczos3 resampling
 .
 Note that OBS Studio requires an OpenGL 3.2 compatible video card.

Package: obs-plugins
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Replaces: obs-studio
Recommends: vlc
Description: recorder and streamer for live video content (plugins)
 OBS is designed for efficiently recording and streaming live video content. It
 supports live RTP streaming to various streaming sites.
 .
 This package contains the plugins.

Package: libobs0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: recorder and streamer for live video content (shared library)
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 This package contains the shared library libobs.

Package: libobs-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libobs0 (= ${binary:Version}), ${misc:Depends}, libsimde-dev
Description: recorder and streamer for live video content (development files)
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 This package contains the development files.
